#ifndef id0ADBCC15BA574485BF3267254090D99B
#define id0ADBCC15BA574485BF3267254090D99B

#include "primitivetypes.hpp"
#include "components/tileiterator.hpp"
#include "components/layer.hpp"

namespace dk {
	template <typename T, size_t D>
	class Layer;

	template <typename T, size_t D>
	class Viewport {
	public:
		typedef Vector<CoordinateScalarType, D> coords;
		typedef typename Layer<T, D>::iterator iterator;

		explicit Viewport ( Layer<T, D>& parLayer );
		Viewport ( Layer<T, D>& parLayer, const coords& parSize, const coords& parPos );
		~Viewport ( void ) noexcept = default;

		Viewport& operator= ( const Viewport& ) = default;

		void setSize ( const coords& parSize ) { m_size = parSize; }
		void setFrom ( const coords& parFrom ) { m_position = parFrom; }

	private:
		coords m_size;
		coords m_position;
		Layer<T, D>& m_layer;
	};
} //namespace dk

#include "implem/viewport.inl"

#endif
